package com.perforce.hws.server.routes.perforce;

import com.perforce.hws.p4base.P4Methods;
import com.perforce.hws.p4base.ResultMap;
import com.perforce.hws.p4base.ServerHandle;
import com.perforce.hws.server.HWSSettings;
import com.perforce.hws.server.ModelConversion;
import com.perforce.hws.server.UsesServerHandles;
import com.perforce.hws.server.sessions.SessionData;

import spark.Request;
import spark.Response;
import spark.Route;

import java.util.List;
import java.util.function.Supplier;
import java.util.stream.Collectors;

/**
 * GET /clients
 */
public class PerforceListClientsRoute implements
        Route,
        P4Methods,
        ModelConversion,
        UsesServerHandles {

    @Override
    public Object handle(Request request, Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            List<ResultMap> resultMapList = exec(serverHandle, "clients");
            Supplier<String> offsetSupplier = offsetSupplier(serverHandle);
            return resultMapList.stream().map(m -> toClientsCommand(m, offsetSupplier))
                    .collect(Collectors.toList());
        });
    }
}
